package com.ruoyi.info.hospital.service;

import com.ruoyi.info.hospital.domain.Hospital;
import com.ruoyi.info.hospital.domain.bo.HospitalRackUpdateBo;
import com.ruoyi.info.hospital.domain.vo.HospitalVo;
import com.ruoyi.info.hospital.domain.bo.HospitalBo;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;

import java.util.Collection;
import java.util.List;

/**
 * 医院信息Service接口
 *
 * @author baifc
 * @date 2025-09-20
 */
public interface IHospitalService {

    /**
     * 查询医院信息分页
     *
     * @param bo 医院信息
     * @return 医院信息集合
     */
    TableDataInfo<HospitalVo> queryPageList(HospitalBo bo, PageQuery pageQuery);

    /**
     * 查询医院信息列表
     *
     * @param bo 医院信息
     * @return 医院信息集合
     */
    List<HospitalVo> queryList(HospitalBo bo);

    /**
     * 查询医院信息
     *
     * @param id 医院信息主键
     * @return 医院信息
     */
    HospitalVo queryById(Long id);

    /**
     * 详情医院信息
     *
     * @param id 医院信息主键
     * @return 医院信息
     */
    Hospital loadById(Long id, Boolean tw);

    /**
     * 新增医院信息
     *
     * @param bo 医院信息
     * @return 结果
     */
    Boolean insertByBo(HospitalBo bo);

    /**
     * 修改医院信息
     *
     * @param bo 医院信息
     * @return 结果
     */
    Boolean updateByBo(HospitalBo bo);

    /**
     * 校验并批量删除医院信息信息
     *
     * @param ids 需要删除的医院信息主键集合
     * @param isValid 是否校验,true-删除前校验,false-不校验
     * @return 结果
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 修改医院上下架状态
     *
     * @param bo
     */
    void updateRackStatus(HospitalRackUpdateBo bo);

    HospitalVo queryDelById(Long id);


    /**
     * 修改二维码
     *
     * @param hospitalId
     * @param qrCodeUrl
     */
    void updateQrCodeUrl(Long hospitalId, String qrCodeUrl);

    String queryNameById(Long id);

    Integer querySumForHome();


    /**
     * 根据id列表查询
     *
     * @param ids
     * @return
     */
    List<HospitalVo> queryListByIds(Collection<Long> ids);
}
